<?php
/*
 * help.php, displays help on nagios configuration file syntax
 * (or anything else in the proper format).
 *
 * Copyright(C) 2004, 2005, 2007 op5 AB
 * All rights reserved.
 *
 */

/*
 * Help file format is as follows:
 * Hashmarks denote comments(for changelog and such).
 *
 * Every new line starting with a colon(':') denotes a textblock
 * initializer(keyword/phrase).
 * Every non-comment line following the initializer is interpreted as text
 * belonging to the aforementioned text-block, until a new line is
 * encountered that starts with a colon. I'm sure you get the idea.
 */

# This file is only ever included from the top-dir help.php, when
# it gets called without an argument. It's ridiculously cumbersome
# to have nested includes when the original programs reside in
# different directories, so we don't include any files directly
# from here, but rely on them to already have been included from
# the primary program directory
$page->html_start('Configuration File Syntax Help ');


$lines = explode("\n", file_get_contents($DATADIR . "syntax-help"));
$blk_name = false;
$i = 0;
$text = false;
$intro = '';
foreach($lines as $line) {
	$line = trim($line);
	if(!strlen($line) || $line[0] == '#') continue;
	if($line[0] == ':') {
		$blk_name = substr($line, 1);
		continue;
	}

	/* text before first initializer is the intro */
	if(!$blk_name) $intro .= $line . "<br />";
	else {
		if(empty($text[$blk_name])) $text[$blk_name] = $line . "<br />\n";
		else $text[$blk_name] .= $line . "<br />";
	}
}

echo "<div class='intro'>$intro</div><br />\n";
echo "There is no quick reference for this page. Use your browsers search functions to find the desired keyword<br />\n";

// create quick-jump table.
// $i = 0;
$foo = array_keys($text);
natsort($foo);

echo "</div></div><div class=\"object-table\"><br /><br />\n";
echo "<table class='max zebra ObjTable'>\n";
echo "<tr class='header'>\n";
echo "<td>Keyword</td>\n";
echo "<td style=\"border-left: 0px; border-right: 0px\">Explanation</td></tr>\n";

foreach($foo as $name) {
	echo "  <tr>\n" .
	     "    <td style=\"border-right: 1px solid #dcdccd; width: 200px\"><a name='" . $name . "'></a>$name</td>\n" .
	     "    <td>$text[$name]\n</td>\n" .
		 "  </tr>\n";
}

echo "</table><br /><br />\n";
$page->html_end();

?>
