--
-- Database design for the autoscan
--

CREATE TABLE IF NOT EXISTS autoscan_settings (
  id INT NOT NULL AUTO_INCREMENT UNIQUE PRIMARY KEY,
  count INT UNSIGNED,
  epoch INT UNSIGNED NOT NULL,
  criteria TEXT NOT NULL,
  name TEXT NOT NULL,
  description TEXT,
  enabled BOOL NOT NULL
) ;

CREATE TABLE IF NOT EXISTS autoscan_results (
  id INT NOT NULL AUTO_INCREMENT UNIQUE PRIMARY KEY,
  address VARCHAR(255) NOT NULL,
  name VARCHAR(255) NOT NULL,
  refs INT UNSIGNED NOT NULL
) ;

CREATE TABLE IF NOT EXISTS autoscan_join (
  id INT NOT NULL AUTO_INCREMENT UNIQUE PRIMARY KEY,
  scan INT UNSIGNED NOT NULL,
  host INT UNSIGNED NOT NULL,
  epoch INT UNSIGNED NOT NULL
) ;

CREATE TABLE IF NOT EXISTS autoscan_blacklist (
  id INT NOT NULL AUTO_INCREMENT UNIQUE PRIMARY KEY,
  address VARCHAR(255) NOT NULL
) ;

ALTER TABLE autoscan_results ADD COLUMN visibility BOOL NOT NULL;
ALTER TABLE autoscan_settings CHANGE count count INT UNSIGNED;
ALTER TABLE autoscan_blacklist CONVERT TO CHARACTER SET latin1 COLLATE latin1_general_cs;
