<?php

/**
 * Service escalations are used to escalate notifications
 * for a particular service.
 */
class serviceescalation_nacoma_Model extends escalation_nacoma_Model
{
	/** object type */
	const TYPE = 'serviceescalation';
	/** master object type */
	var $master_obj_type        = 'service';
	/** Variable in this object identifying the master object */
	var $master_obj_identifier 	= 'service';

	public $properties = array (
		'topic' => NULL,
		'var_index' => array (
			'service' => 'select',
			'contacts' => 'mselect',
			'contact_groups' => 'mselect',
			'first_notification' => 'int',
			'last_notification' => 'int',
			'notification_interval' => 'int',
			'escalation_period' => 'select',
			'escalation_options' => 'checkbox',
			'register' => 'bool',
			'file_id' => 'select'
		),
		'widget' => array (
			'service' => 'hidden',
			'register' => 'hidden'
		),
		'default' => array (
			'escalation_options' => array (
				'w',
				'c'
			),
			'file_id' => 'etc/serviceescalations.cfg'
		),
		'required' => array (
			'service',
			'file_id'
		),
		'special' => array (
			'service' => 'service',
			'contacts' => 'contact',
			'contact_groups' => 'contactgroup',
			'escalation_period' => 'timeperiod',
			'escalation_options' => array (
				'c' => 'Critical',
				'w' => 'Warning',
				'u' => 'Unknown',
				'r' => 'Recovery',
				'n' => false
			),
			'file_id' => 'FILE'
		)
	);

	/**
	 * Return the mayi resource for the object
	 * @see object_nacoma_Model::mayi_resource()
	 */
	public function mayi_resource() {
		return "monitor.monitoring.serviceescalations";
	}

	function get_object_by_name($name)
	{
		$table = self::get_objects_for_user();
		$this->id = array_search($name, $table);
		return $this->get_object();
	}
}
