<?php

/**
 * A service group definition is used to group one or more services together for
 * simplifying configuration.
 */
class servicegroup_nacoma_Model extends naemon_nacoma_Model
{
	/** object type */
	const TYPE = 'servicegroup';

	public $properties = array (
		'topic' => 'servicegroup_name',
		'var_index' => array (
			'servicegroup_name' => 'string',
			'alias' => 'string',
			'members' => 'mselect',
			'servicegroup_members' => 'mselect',
			'notes' => 'string',
			'notes_url' => 'notesurl',
			'action_url' => 'string',
			'file_id' => 'select',
			'register' => 'bool'
		),
		'widget' => array (
			'register' => 'hidden'
		),
		'required' => array (
			'servicegroup_name',
			'file_id'
		),
		'default' => array (
			'file_id' => 'etc/servicegroups.cfg'
		),
		'special' => array (
			'members' => 'service',
			'servicegroup_members' => 'servicegroup',
			'file_id' => 'FILE'
		)
	);

	/**
	 * Return the mayi resource for the object
	 * @see object_nacoma_Model::mayi_resource()
	 */
	public function mayi_resource() {
		return "monitor.monitoring.servicegroups";
	}
}
