<?php

Event::add('ninja.setup.contact', function () {

	$logger = op5log::instance('nacoma');
	$data = Event::$data;

	/**
	 * From here chaos ensues, the import/export functionality of Nacoma
	 * is not easily available from Ninja (global functions and state).
	 * So we invoke them via the old _deprecated_ Nacoma CLI API, since
	 * I did not feel it was within scope of this issue to refactor the
	 * import/export includes and their users (Nacoma/HTTP API).
	 */
	$logger->log('notice', "Importing initial Naemon configuration");

	proc::open(array(
		'php', '/opt/monitor/op5/nacoma/api/monitor.php',
		'-a', 'undo_config', // Implies reload from configuration files
		'-u', $data['user']['username']
	));

	$logger->log('notice', "Creating contact for administrative user");

	/**
	 * Even worse was that I though that maybe, just maybe this nacoma model
	 * could be instatiable, modifiable and savable without much pain, but alas
	 * it has dependencies on global nacoma functions/state not available from
	 * inside ninja.
	 */
	if(proc::open(array(
		'php', '/opt/monitor/op5/nacoma/api/monitor.php',
		'-t', 'contact',
		'-o', 'contact_name='. $data['user']['username'],
		'-o', 'alias='. $data['user']['realname'],
		'-o', 'template=default-contact',
		'-u', $data['user']['username']
	), $stdout, $stderr)) {
	$logger->log('notice', "Created contact for administrative user");
	} else {
		throw new Exception($stderr);
	}

	if ($stdout) $logger->log('error', $stdout);
	if ($stderr) $logger->log('error', $stderr);

	$logger->log('notice', "Exporting Naemon configuration");

	/**
	 * And export the configuration again now that we've added the contact.
	 */
	proc::open(array(
		'php', '/opt/monitor/op5/nacoma/api/monitor.php',
		'-a', 'save_config', // Implies export into configuration files
		'-u', $data['user']['username']
	));

});
