<?php

/**
 * Select-derived widget for choosing an image in a javascripty way
 */
class Image_Nacomawidget extends Select_Nacomawidget {
	static $already_rendered_icons = false; /**< Control that widget elements are only rendered in HTML once - we move those elements around */
	/**
	 * Create area for host logo selection with correct
	 * HTML IDs and classes to make javascript function to work.
	 * NOTE: All IDs and classes are there for more than just presentation
	 * purpose. If anyone of the following IDs and classes are altered,
	 * the corresponding changes MUST be made in js/common.js or it will stop
	 * working.
	 * @param $sel_tmp id => image style array
	 * @param $value Pre-selected image
	 * @param $obj Nagios-specific php object class
	 * @param $token ??
	 */
	function host_logo_selection($sel_tmp, $value, $obj, $token)
	{
		echo '<div class="Image_Nacomawidget_wrapper">';
		echo '<div class="selected_preview_container" title="Click to select/change image">'.
		'<img src="'.(!empty($value) ? '/ninja/application/media/images/logos/'.$value:"images/icons/no_image.png").
		'" class="selected_preview"/></div>';
		echo '<span class="remove_image" style="'.(empty($value) ? "display: none;" : '') .'">Remove icon</span>';
		if (!self::$already_rendered_icons) {
			self::$already_rendered_icons = true;
			echo "<div class=\"image_container\">";
			foreach ($sel_tmp as $id => $img) {
				if (empty($img)) continue;
				$name_part = explode('.', $img);
				$img_name = false;
				for ($i=0; $i < sizeof($name_part) - 1; $i++) {
					$img_name .= $name_part[$i]; # strip filename extension
				}
				echo '<img class="host_logo_images" data-filename="'.$img.'" id="image_'.preg_replace("/\./", "_", $img).
				'" src="/ninja/application/media/images/logos/'.$img.'"'.
				' title="'.ucfirst(str_replace('_', ' ', $img_name)).'" alt="'.ucfirst(str_replace('_', ' ', $img_name)).'"/>';
			} # See note above if any changes to element IDs or classes has to be made!
			echo "</div>";
		}
		echo '<span class="image_realname">'.$value.'</span>';
		echo '<input type="hidden" name="'.$this->get_id($obj, $token).'" id="'.$this->get_id($obj, $token).
		'" value="'.$value.'" class="host_logo_selected" />';
		echo '</div>';
	}

	function render($obj, $token, $value) {
		$sel_tmp = $obj->properties['special'][$token];

		# If this variable isn't required, add an empty
		# item to the selection list.
		if (!in_array($token, $obj->properties['required']) && !empty($sel_tmp))
			$sel_tmp[0] = '';

		$this->host_logo_selection($sel_tmp, $value, $obj, $token);
	}
}
