<?php

if (!isset($deletable)) $deletable = false;
if (!isset($editable)) $editable = false;
if (!isset($createable)) $createable = false;

echo form::open('', array(
	'id' => $formid,
	'class' => 'renderable',
	'action' => $action
));

foreach ($renderable->get_renderable_fields() as $id => $field) {

	$getter = "get_$id";
	$value = $renderable->$getter();

	if ($editable && isset($field['key'])) {
		echo form::hidden($id, $value);
		continue;
	}

	echo form::open_fieldset(array(
		'type' => $field['type']
	));

	echo form::label($id, $field['label']);

	if ($field['type'] === 'select') {

		$options = array();
		$data = array('name' => $id, 'id' => $id);

		if (isset($field['filters'])) {
			$data['data-filterable'] = 'filterable';
			$data['data-type'] =  $field['filters'];
			if (count($value) >= 1) {
				$options = array_combine(array_values($value), $value);
			}
		} elseif (isset($field['options'])) {
			$options = $field['options'];
		}

		if (isset($field['multiple'])) {
			$data['multiple'] = 'multiple';
			$data['name'] = $id . '[]';
		}

		echo form::dropdown($data, $options);

	} elseif ($field['type'] === 'textarea') {
		echo form::textarea($id, $value);
	} elseif ($field['type'] === 'text') {
		echo form::input($id, $value);
	} elseif ($field['type'] === 'password') {
		echo form::password($id, '');
		echo form::open_fieldset(array(
			'type' => $field['type'] . '-repeat'
		));
		echo form::label($id . '-repeat', $field['label'] . ' Repeat');
		echo form::password($id . '-repeat', '');
		echo form::close_fieldset();
	} elseif ($field['type'] === 'checkbox') {
		echo form::checkbox($id, $value);
	}

	echo form::close_fieldset();

}

if ($editable) {
	echo form::button(array(
		'formaction' => "$action/update",
		'name' => 'save',
	), 'Save ' . $renderable->get_key());
} elseif ($createable) {
	echo form::button(array(
		'formaction' => "$action/create",
		'name' => 'create',
	), 'Create new user');
}

if ($deletable) {
	echo form::button(array(
		'formaction' => "$action/delete",
		'name' => 'delete',
		'onclick' => "return confirm('Are you sure you wish to delete this item?')",
		'class' => "secondary"
	), 'Delete ' . $renderable->get_key());
}

echo form::close();
